//+------------------------------------------------------------------+
//|                                CAMARILLA AHG A.mq4               |
//|                     VAN         camarilladt7                     |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "CAMARILLA AHG A"
#property link      "CAMARILLA AHG A"

#property indicator_chart_window
//---- input parameters

extern double  GMTshiftSun=0;   //sun into mon cams use this corrected value for fri data 
extern double  GMTshift=1;
extern bool    Pivot = true;
extern bool    H2_L2 = false;
extern bool    H1_L1 = false;
extern color   TextColor = White;
extern int     FontSize = 12;//8
extern color    PivotColor = Magenta;
extern color   H_Color = SpringGreen;
extern color   L_Color = SpringGreen;

double P, H3, H4, H5, H2, H1;
double L3, L4, L5, L2, L1;
double LastHigh,LastLow,x;
bool firstL3=true;
bool firstH3=true;

double D1=0.091667;
double D2=0.183333;
double D3=0.2750;
double D4=0.55;


// Fib variables

double yesterday_high=0;
double yesterday_low=0;
double yesterday_close=0;

int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

if (Pivot)
{
ObjectDelete("P Label");
ObjectDelete("P Line");
}
ObjectDelete("H5 Label");
ObjectDelete("H5 Line");
ObjectDelete("H4 Label");
ObjectDelete("H4 Line");
ObjectDelete("H3 Label");
ObjectDelete("H3 Line");
ObjectDelete("L3 Label");
ObjectDelete("L3 Line");
ObjectDelete("L4 Label");
ObjectDelete("L4 Line");
ObjectDelete("L5 Label");
ObjectDelete("L5 Line");

ObjectDelete("H1 Label");
ObjectDelete("H1 Line");
ObjectDelete("H2 Label");
ObjectDelete("H2 Line");
ObjectDelete("L1 Label");
ObjectDelete("L1 Line");
ObjectDelete("L2 Label");
ObjectDelete("L2 Line");
//----


   return(0);
  }



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- TODO: add your code here
double day_high=0;
double day_low=0;
double yesterday_open=0;
double today_open=0;
double Q=0,nQ=0,nD=0,D=0;
double shift_corrected;
int cnt=720;
double cur_day=0;
double prev_day=0;

double rates_d1[2][6];

//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}

//---- Get new daily prices & calculate pivots
if (DayOfWeek()==1)  shift_corrected=GMTshiftSun;
//if ((DayOfWeek()==2) && (Hour() < GMTshift)) shift_corrected=(-GMTshiftSun-24);
else    shift_corrected=GMTshift;

while (cnt!= 0)
{
	cur_day = TimeDay(Time[cnt]- (shift_corrected*3600));
	
	if (prev_day != cur_day)
	{
		yesterday_close = Close[cnt+1];
		today_open = Open[cnt];
		yesterday_high = day_high;
		yesterday_low = day_low;

		day_high = High[cnt];
		day_low  = Low[cnt];

		prev_day = cur_day;
	}
   
   if (High[cnt]>day_high)
   {
      day_high = High[cnt];
   }
   if (Low[cnt]<day_low)
   {
      day_low = Low[cnt];
   }
	
	cnt--;

}

//============================================================================

D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);
//------ Pivot Points ------

P = (yesterday_high + yesterday_low + yesterday_close)/3;//Pivot
//---- To display all 8 Camarilla pivots remove comment symbols below and
// add the appropriate object functions below
H5 = (yesterday_high/yesterday_low)*yesterday_close;
H4 = ((yesterday_high - yesterday_low)* D4) + yesterday_close;
H3 = ((yesterday_high - yesterday_low)* D3) + yesterday_close;
H2 = ((yesterday_high - yesterday_low) * D2) + yesterday_close;
H1 = ((yesterday_high - yesterday_low) * D1) + yesterday_close;

L1 = yesterday_close - ((yesterday_high - yesterday_low)*(D1));
L2 = yesterday_close - ((yesterday_high - yesterday_low)*(D2));
L3 = yesterday_close - ((yesterday_high - yesterday_low)*(D3));
L4 = yesterday_close - ((yesterday_high - yesterday_low)*(D4));
L5 = yesterday_close - (H5 - yesterday_close);

//================================================================================


if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}

 if (StringSubstr(Symbol(),3,3)=="JPY")
      {
      nQ=nQ/100;
      nD=nD/100;
      }
      


//---- Set line labels on chart window
 if (Pivot)
   {

      if(ObjectFind("P label") != 0)
      {
      ObjectCreate("P label", OBJ_TEXT, 0, Time[20], P);
      ObjectSetText("P label", "Cam Pivot", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("P label", 0, Time[20], P);
      }

//---  Draw  Pivot lines on chart

      if(ObjectFind("P line") != 0)
      {
      ObjectCreate("P line", OBJ_HLINE, 0, Time[40], P);
      ObjectSet("P line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("P line", OBJPROP_COLOR, PivotColor);
      }
      else
      {
      ObjectMove("P line", 0, Time[40], P);
      }

  }


//============================ THE CAMARILLA ==================================
   if(ObjectFind("H5 label") != 0)
      {
      ObjectCreate("H5 label", OBJ_TEXT, 0, Time[20], H5);
      ObjectSetText("H5 label", " H5 LB TARGET", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H5 label", 0, Time[20], H5);
      }
      
      if(ObjectFind("H4 label") != 0)
      {
      ObjectCreate("H4 label", OBJ_TEXT, 0, Time[20], H4);
      ObjectSetText("H4 label", " H4 LONG BREAKOUT", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H4 label", 0, Time[20], H4);
      }

      if(ObjectFind("H3 label") != 0)
      {
      ObjectCreate("H3 label", OBJ_TEXT, 0, Time[20], H3);
      ObjectSetText("H3 label", " H3 SHORT", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H3 label", 0, Time[20], H3);
      }

      if(ObjectFind("L3 label") != 0)
      {
      ObjectCreate("L3 label", OBJ_TEXT, 0, Time[20], L3);
      ObjectSetText("L3 label", " L3 LONG", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L3 label", 0, Time[20], L3);
      }

      if(ObjectFind("L4 label") != 0)
      {
      ObjectCreate("L4 label", OBJ_TEXT, 0, Time[20], L4);
      ObjectSetText("L4 label", " L4 SHORT BREAKOUT", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L4 label", 0, Time[20], L4);
      }
      
      if(ObjectFind("L5 label") != 0)
      {
      ObjectCreate("L5 label", OBJ_TEXT, 0, Time[20], L5);
      ObjectSetText("L5 label", " L5 SB TARGET", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L5 label", 0, Time[20], L5);
      }

//================ Draw Camarilla lines on Chart======================================

      if(ObjectFind("H5 line") != 0)
      {
      ObjectCreate("H5 line", OBJ_HLINE, 0, Time[40], H5);
      ObjectSet("H5 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H5 line", OBJPROP_COLOR, H_Color);
      ObjectSet("H5 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("H5 line", 0, Time[40], H5);
      }
      
      if(ObjectFind("H4 line") != 0)
      {
      ObjectCreate("H4 line", OBJ_HLINE, 0, Time[40], H4);
      ObjectSet("H4 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H4 line", OBJPROP_COLOR, H_Color);
      ObjectSet("H4 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("H4 line", 0, Time[40], H4);
      }

      if(ObjectFind("H3 line") != 0)
      {
      ObjectCreate("H3 line", OBJ_HLINE, 0, Time[40], H3);
      ObjectSet("H3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H3 line", OBJPROP_COLOR, H_Color);
      ObjectSet("H3 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("H3 line", 0, Time[40], H3);
      }

      if(ObjectFind("L3 line") != 0)
      {
      ObjectCreate("L3 line", OBJ_HLINE, 0, Time[40], L3);
      ObjectSet("L3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L3 line", OBJPROP_COLOR, L_Color);
      ObjectSet("L3 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("L3 line", 0, Time[40], L3);
      }

      if(ObjectFind("L4 line") != 0)
      {
      ObjectCreate("L4 line", OBJ_HLINE, 0, Time[40], L4);
      ObjectSet("L4 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L4 line", OBJPROP_COLOR, L_Color);
      ObjectSet("L4 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("L4 line", 0, Time[40], L4);
      }
      
      if(ObjectFind("L5 line") != 0)
      {
      ObjectCreate("L5 line", OBJ_HLINE, 0, Time[40], L5);
      ObjectSet("L5 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L5 line", OBJPROP_COLOR, L_Color);
      ObjectSet("L5 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("L5 line", 0, Time[40], L5);
      }

//=================================H2_L2=======================================     
  if (H2_L2 == true)
  
  {  if(ObjectFind("H2 line") != 0)
      {
      ObjectCreate("H2 line", OBJ_HLINE, 0, Time[40], H2);
      ObjectSet("H2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H2 line", OBJPROP_COLOR, H_Color);
      ObjectSet("H2 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("H2 line", 0, Time[40], H2);
      }
   
     if(ObjectFind("L2 line") != 0)
      {
      ObjectCreate("L2 line", OBJ_HLINE, 0, Time[40], L2);
      ObjectSet("L2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L2 line", OBJPROP_COLOR, L_Color);
      ObjectSet("L2 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("L2 line", 0, Time[40], L2);
      } 
      
      
    if(ObjectFind("H2 label") != 0)
      {
      ObjectCreate("H2 label", OBJ_TEXT, 0, Time[20], H2);
      ObjectSetText("H2 label", "H2", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H2 label", 0, Time[20], H2);
      }
      
      if(ObjectFind("L2 label") != 0)
      {
      ObjectCreate("L2 label", OBJ_TEXT, 0, Time[20], L2);
      ObjectSetText("L2 label", "L2", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L2 label", 0, Time[20], L2);
      }   
   }
//=================================H1_L1=======================================     
   
     if (H1_L1 == true)
       
 {  if(ObjectFind("H1 line") != 0)
      {
      ObjectCreate("H1 line", OBJ_HLINE, 0, Time[40], H1);
      ObjectSet("H1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H1 line", OBJPROP_COLOR, H_Color);
      ObjectSet("H1 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("H1 line", 0, Time[40], H1);
      }
 
    if(ObjectFind("L1 line") != 0)
      {
      ObjectCreate("L1 line", OBJ_HLINE, 0, Time[40], L1);
      ObjectSet("L1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L1 line", OBJPROP_COLOR, L_Color);
      ObjectSet("L1 line", OBJPROP_WIDTH, 1);
      }
      else
      {
      ObjectMove("L1 line", 0, Time[40], L1);
      }
  
  
   if(ObjectFind("H1 label") != 0)
      {
      ObjectCreate("H1 label", OBJ_TEXT, 0, Time[20], H1);
      ObjectSetText("H1 label", "H1", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("H1 label", 0, Time[20], H1);
      }
      
   if(ObjectFind("L1 label") != 0)
      {
      ObjectCreate("L1 label", OBJ_TEXT, 0, Time[20], L1);
      ObjectSetText("L1 label", "L1", FontSize, "Arial", TextColor);
      }
      else
      {
      ObjectMove("L1 label", 0, Time[20], L1);
      }
      
      
   }
   
//================================================================        

   return(0);
  }
//+------------------------------------------------------------------+